package com.base.scanqrclear.ui.website

import androidx.activity.addCallback
import androidx.core.view.updatePadding
import androidx.lifecycle.ViewModelProvider
import com.base.scanqrclear.R
import com.base.scanqrclear.ads.AdsMgr
import com.base.scanqrclear.ads.AdsShowCallBack
import com.base.scanqrclear.base.BaseActivity
import com.base.scanqrclear.bean.FunctionUIBean
import com.base.scanqrclear.bean.WebsiteUIBean
import com.base.scanqrclear.bean.config.AdConfigBean
import com.base.scanqrclear.databinding.ActivityWebsiteCodeBinding
import com.base.scanqrclear.ui.vm.QrViewModel
import com.base.scanqrclear.ui.widget.InputNameDialog.showInputNameDialog
import com.base.scanqrclear.utils.BarUtils
import com.base.scanqrclear.utils.BitmapUtils.saveBitmapToFile
import com.base.scanqrclear.utils.ClipboardUtils.copyText
import com.base.scanqrclear.utils.IntentUtils.intentShareImage
import com.base.scanqrclear.utils.IntentUtils.intentViewHttp
import com.base.scanqrclear.utils.LogEx
import com.base.scanqrclear.utils.QRCodeUtils.generateQRCode
import com.base.scanqrclear.utils.SpJsonUtils
import com.base.scanqrclear.utils.ToastUtils.toast
import com.google.gson.Gson
import java.io.File

class WebsiteCodeActivity : BaseActivity<ActivityWebsiteCodeBinding>(ActivityWebsiteCodeBinding::inflate) {

    private var websiteUIBean = WebsiteUIBean()
    private var tempImagePath: String = ""
    private var qrString = ""
    private val viewModel by lazy(LazyThreadSafetyMode.NONE) {
        ViewModelProvider(this)[QrViewModel::class.java]
    }


    override fun onResumeOneShoot() {
        super.onResumeOneShoot()
        val flag = changeLanguage()
        if (flag) return

        AdsMgr.showBanner(binding.flBanner, false)
    }

    override fun initView() {
        super.initView()
        binding.clTop.updatePadding(top = BarUtils.getStatusBarHeight())
        AdsMgr.showNative(binding.flAd, R.layout.layout_admob_item)

        val data = intent.extras?.getString("data")

        data?.let {
            websiteUIBean = Gson().fromJson(data, WebsiteUIBean::class.java)
            binding.tvHttp.text = websiteUIBean.http
            qrString = websiteUIBean.http
        }

        Thread {
            val bitmap = generateQRCode(qrString, 735, 735, 5)
            runOnUiThread {
                binding.ivQr.setImageBitmap(bitmap)
                val file = File(cacheDir, System.currentTimeMillis().toString() + ".jpg")
                bitmap?.let {
                    val flag = saveBitmapToFile(it, file.absolutePath)
                    LogEx.logDebug(TAG, "flag=$flag tempImage=${file.absolutePath}")
                    if (flag) {
                        tempImagePath = file.absolutePath
                    }
                }
                if (websiteUIBean.needCreate) {
                    websiteUIBean.needCreate = false
                    SpJsonUtils.addJsonBean<WebsiteUIBean>(FunctionUIBean.KEY_WEBSITE, websiteUIBean)
                }
            }
        }.start()
    }

    override fun initListener() {
        super.initListener()
        onBackPressedDispatcher.addCallback {
            if (AdConfigBean.adsConfigBean.functionBackShowAd) {
                AdsMgr.showInsert(this@WebsiteCodeActivity, true, object : AdsShowCallBack() {
                    override fun close(where: Int) {
                        finishToMainTop()
                    }

                    override fun failed(where: Int) {
                        finishToMainTop()
                    }

                    override fun googleFailed(where: Int) {
                        finishToMainTop()
                    }
                })
            } else {
                finishToMainTop()
            }
        }
        binding.flBack.setOnClickListener {
            onBackPressedDispatcher.onBackPressed()
        }
        binding.llShare.setOnClickListener {
            val intent = intentShareImage(this, tempImagePath)
            runCatching {
                startActivity(intent)
            }
        }
        binding.llDownload.setOnClickListener {
            kotlin.runCatching {
                val newName = File(tempImagePath).name
                showInputNameDialog(newName) { name ->
                    viewModel.copyFileToDownloads(this, name, tempImagePath)
                }
            }
        }
        binding.llCopy.setOnClickListener {
            copyText(TAG, websiteUIBean.http)
            toast("Copied to clipboard", true)
        }
        binding.flSearch.setOnClickListener {
            val intent = intentViewHttp(websiteUIBean.http)
            try {
                startActivity(intent)
            } catch (e: Exception) {
                toast("No application was found to handle the http view", true)
            }
        }
    }

}